<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "competitor_meta_data".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CompetitorMetaData".
 *
 * Columns in table "competitor_meta_data" available as properties of the model,
 * and there are no model relations.
 *
 * @property string $id
 * @property string $entity
 * @property string $entity_id_attribute
 * @property string $entity_id
 * @property string $attribute_name
 * @property string $attribute_value
 * @property string $data
 *
 */
abstract class BaseCompetitorMetaData extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'competitor_meta_data';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CompetitorMetaData|CompetitorMetaDatas', $n);
    }

    public static function representingColumn()
    {
        return 'entity';
    }

    public function rules()
    {
        return array(
            array('entity, entity_id_attribute, entity_id, attribute_name', 'length', 'max'=>100),
            array('attribute_value, data', 'safe'),
            array('entity, entity_id_attribute, entity_id, attribute_name, attribute_value, data', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, entity, entity_id_attribute, entity_id, attribute_name, attribute_value, data', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'entity' => Yii::t('app', 'Entity'),
            'entity_id_attribute' => Yii::t('app', 'Entity Id Attribute'),
            'entity_id' => Yii::t('app', 'Entity'),
            'attribute_name' => Yii::t('app', 'Attribute Name'),
            'attribute_value' => Yii::t('app', 'Attribute Value'),
            'data' => Yii::t('app', 'Data'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('entity', $this->entity, true);
        $criteria->compare('entity_id_attribute', $this->entity_id_attribute, true);
        $criteria->compare('entity_id', $this->entity_id, true);
        $criteria->compare('attribute_name', $this->attribute_name, true);
        $criteria->compare('attribute_value', $this->attribute_value, true);
        $criteria->compare('data', $this->data, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
